Subject: [bitcoindev] [BIP Proposal] Standard Encrypted Wallet Payload + Standard Encryption Envelope formats

From: 'Keyser Söze' via Bitcoin Development Mailing List <[email-masked]>
Date: Sat, 13 Sep 2025 12:00:39 -0700 (PDT)

Hi community,

I’m sharing two early draft BIPs aimed at improving wallet interoperability 
and security in the Bitcoin ecosystem. Together, they address the absence 
of an interoperable, canonical, secure format for wallet backups and 
transfers.

*1. Standard Encrypted Wallet Payload*
A CBOR based format for serialising wallet data — including 
descriptor-based accounts, optional transactions/UTXOs, metadata, and root 
secrets. It cleanly separates the core data structure from its 
cryptographic protection, with encryption mandated via a companion 
standard. This builds on BIPs 329, 380, 388, and 389, emphasising 
extensibility and deterministic encoding to enable reliable restores across 
wallets.
The draft BIP can be found here:
https://gist.github.com/KeysSoze/7109a7f0455897b1930f851bde6337e3

*2. Standard Wallet Encryption Envelope*
A secure, versioned container for encrypting the payload using a password 
derived key with Argon2id, with scope for future extensions such as 
asymmetric encryption. It aims to provide robust protection while keeping 
the format modular and library-agnostic.
The draft BIP can be found here:
https://gist.github.com/KeysSoze/866d009ccd082edf6802df240154b20d

Both drafts are at a very early stage. I’m seeking feedback on the overall 
approach, technical details, potential gaps, and ways to improve them 
before formalising further or submitting PRs to the BIPs repository.

Thanks in advance for your review and input.

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/06b5d067-7293-4618-b3c5-510380a55efan%40googlegroups.com.